#ifndef ELDBUS_MODEL_PROXY_EO_HH
#define ELDBUS_MODEL_PROXY_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_model.eo.h"
#include "eldbus_model_proxy.eo.h"
#include "eo_base.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_model.eo.hh"
#include "eo_base.eo.hh"
namespace eldbus { namespace model { 
struct Proxy;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::eldbus::model::Proxy> : ::std::true_type {}; } }

namespace eo_cxx {
namespace eldbus { namespace model { 
struct Proxy {
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type name_get() const;
   static Eo_Class const* _eo_class()
   {
      return ELDBUS_MODEL_PROXY_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::eldbus::model::Proxy() const;
   operator ::eldbus::model::Proxy&();
   operator ::eldbus::model::Proxy const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Proxy,  ::efl::Model,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Proxy const ,  ::efl::Model const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace eldbus { namespace model { 
struct Proxy : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::efl::Model)
   , EO_CXX_INHERIT( ::eo::Base)
{
   explicit Proxy( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Proxy(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Proxy(Proxy const& other) = default;
   Proxy(Proxy&& other) = default;
   Proxy& operator=(Proxy const& other) = default;
   Proxy& operator=(Proxy&& other) = default;
   Proxy()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Proxy( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Proxy(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type name_get() const;
   static Eo_Class const* _eo_class()
   {
      return ELDBUS_MODEL_PROXY_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Proxy,  ::efl::Model,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Proxy const ,  ::efl::Model const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Proxy) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Proxy>::value, "");
} } 
#include "eldbus_model_proxy.eo.impl.hh"
#endif
